before_script:
 # Decrypt server key
 - openssl aes-256-cbc -d -md md5 -in assets/server.key.enc -out assets/server.key -k $SERVER_KEY_PASSWORD
 # Install jq
 - apt update && apt -y install jq

 # Setup SFDX environment variables
 - export CLIURL=https://developer.salesforce.com/media/salesforce-cli/sfdx-linux-amd64.tar.xz
 - export SFDX_AUTOUPDATE_DISABLE=false
 - export SFDX_USE_GENERIC_UNIX_KEYCHAIN=true
 - export SFDX_DOMAIN_RETRY=300
 - export ROOTDIR=force-app/main/default/
 - export SCRATCH_ORG_ALIAS="ApexHours"

 # Install Salesforce CLI
 - mkdir sfdx
 - wget -qO- $CLIURL | tar xJ -C sfdx --strip-components 1
 - "./sfdx/install"
 - export PATH=./sfdx/$(pwd):$PATH
 # Output CLI version and plug-in information
 - sfdx --version
 - sfdx plugins --core

stages:
 - build-testing
 - prod-deploy


build-testing:
 stage: build-testing
 script:
 # Authenticate to the Dev Hub using the server key
 - sfdx force:auth:jwt:grant --clientid $SF_CONSUMER_KEY_PROD --jwtkeyfile assets/server.key --username $SF_USERNAME_PROD --setdefaultdevhubusername --setalias HubOrg
 # Create scratch org
 - sfdx force:org:create --targetdevhubusername HubOrg --setdefaultusername --definitionfile config/project-scratch-def.json --setalias $SCRATCH_ORG_ALIAS --wait 10 --durationdays 7
 - sfdx force:org:display --targetusername $SCRATCH_ORG_ALIAS
 # Push source to scratch org (This is with source code, all files, etc)
 - sfdx force:source:push --targetusername $SCRATCH_ORG_ALIAS
 # Delete Scratch Org
 - sfdx force:org:delete --targetusername $SCRATCH_ORG_ALIAS --noprompt

prod-deploy:
 stage: prod-deploy
 when: manual
 script:
 # Authenticate to the Dev Hub using the server key
 - sfdx force:auth:jwt:grant --clientid $SF_CONSUMER_KEY_PROD --jwtkeyfile assets/server.key --username $SF_USERNAME_PROD --setdefaultdevhubusername --setalias HubOrg
 # Push source to scratch org (This is with source code, all files, etc)
 - sfdx force:source:deploy --targetusername HubOrg -p $ROOTDIR